//Drag and Drop functionality
//Start

var startDate = "21/2/2018";
var endDate = "26/2/2018";

var globalData = [];
var xData = [];
var yData = [];
var dataArray = [];
var dateIndex = 0;
var dayIndex = 0;
var subIndex = 0;
var dropdownFile = document.getElementById("fileName");
var url = "../data/comparefood.csv";

document.getElementById('startDate').valueAsDate = new Date("30/1/2018");
document.getElementById('endDate').valueAsDate = new Date("31/12/2018");

function resetHtml()
{
  document.getElementById("div2").innerHTML = "";
  document.getElementById("div3").innerHTML = "";
  document.getElementById("div2").innerHTML = "<p id=\"p2\">X-Axis</p><br></div>";
  document.getElementById("div3").innerHTML = "<p id=\"p2\">Y-Axis</p><br></div>";
}

function allowDrop(ev) {
  ev.preventDefault();
}

function dragData(ev) {
  ev.dataTransfer.setData("text", ev.target.id);
	//createGraph()
}

function dropData(ev) {
  ev.dataTransfer.setData("text", ev.target.id);
	ev.preventDefault();
	var data = ev.dataTransfer.getData("text");
	ev.target.appendChild(document.getElementById(data));

  var indexX = xData.indexOf(data);
  if (indexX !== -1) {
    xData.splice(indexX, 1);
    document.getElementById("div2").innerHTML = "";
    document.getElementById("div2").innerHTML = "<p id=\"p2\">X-Axis</p><br></div>";

  }

  var indexY = yData.indexOf(data);
  if (indexY !== -1) {
    yData.splice(indexY, 1);
  }
  console.log(data);
  console.log(xData);
  console.log(yData);
	createGraph();
}

function dropX(ev) {
  ev.preventDefault();
  var data = ev.dataTransfer.getData("text");
  ev.target.appendChild(document.getElementById(data));
	console.log(data.trim() + globalData.indexOf[data.trim()]);
	xData.push(data);
	console.log(xData);

  subIndex = globalData[0].indexOf(data.trim());
  var subVariable = [];

  var index = yData.indexOf(data);
  if (index !== -1) {
    yData.splice(index, 1);
  }

  for(var i = 0; i<globalData.length; i++)
  {
    subVariable[i] = globalData[i][subIndex];
  }

  subVariable = [... new Set(subVariable)];
  subVariable.shift();
  subVariable.pop();

  for(var i = 0; i < subVariable.length; i++)
  {
    var chk = document.createElement('input');
            chk.setAttribute('type', 'checkbox');
            chk.setAttribute('id', subVariable[i]);
            chk.setAttribute('value', subVariable[i]);
            chk.setAttribute('name', 'sub');
            chk.onchange = function(){createGraph();};

            var lbl = document.createElement('label');
            lbl.setAttribute('for', 'prodName' + i);
            lbl.appendChild(document.createTextNode(subVariable[i]));

            var br = document.createElement("br");

            div2.appendChild(br);
            div2.appendChild(chk);
            div2.appendChild(lbl);
            div2.appendChild(br);

            document.getElementById("div2").focus();
  }
	createGraph();
}

function dropY(ev) {
  ev.preventDefault();
  var data = ev.dataTransfer.getData("text");
  ev.target.appendChild(document.getElementById(data));
	console.log(data + " y");
	yData.push(data);
	console.log(yData);

  var index = xData.indexOf(data);
  if (index !== -1) {
    xData.splice(index, 1);
  }
	createGraph();
}

//Data Type is Text
//End

function getDate(){

  var x = document.getElementById("startDate");
  var y = document.getElementById("endDate");
  startDate = x.value;
  endDate = y.value;

  var ptag = document.getElementById('p4');
        ptag.innerHTML = "Date range set from "+ formatDateToUse(startDate)
        + " to " + formatDateToUse(endDate);
  createGraph();
}

function getMonth(dateToFormat)
{
  var dateParts = dateToFormat.split("/");

  return dateParts[1];
}

function formatDate(dateToFormat)
{
  var dateParts = dateToFormat.split("/");

  if(dateParts[1]<10)
  {
    dateParts[1] = "0" + dateParts[1];
  }

  return dateParts[2]+"-"+dateParts[1]+"-"+dateParts[0];
}

function formatDateToUse(dateToFormat)
{
  var dateParts = dateToFormat.split("-");

  if(dateParts[1]<10)
  {
    dateParts[1] = dateParts[1].replace("0","");
  }

  return dateParts[2]+"/"+dateParts[1]+"/"+dateParts[0];
}

function parseHeader() {
  resetHtml();
  createTable();
	Papa.parse(dropdownFile.options[dropdownFile.selectedIndex].value, {
		download: true,
		header: true,
		complete: function(results) {
      xData = [];
      yData = [];
      dataArray = [];
			var allData = "";
			var dataDrag = "<tr><td class=\"data\"><div class=\"bordered\" height=\"45\" width=\"300\" draggable=\"true\" ondragstart=\"dragData(event)\" id=\""
			var dataDrag2 = "\">"
			var dataDrag3 = "</div></td></tr>"
			for(var i = 0; i < results.meta['fields'].length; i++)
			{
				// if(results.meta['fields'][i] != 'undefined' && !results.meta['fields'][i].includes("Billing") && !results.meta['fields'][i].includes("Shipping"))
				// {
	      //   allData += dataDrag + results.meta['fields'][i] + " " + dataDrag2 + results.meta['fields'][i] + dataDrag3 + "\n";
				// 	dataArray.push(results.meta['fields'][i]);
			  // }

        if(results.meta['fields'][i] != 'undefined')
				{
	        allData += dataDrag + results.meta['fields'][i] + " " + dataDrag2 + results.meta['fields'][i] + dataDrag3 + "\n";
					dataArray.push(results.meta['fields'][i]);
			  }
			}
      dateIndex = dataArray.indexOf("Order Date");
      dayIndex = dataArray.indexOf("Day");
			document.getElementById("table1").innerHTML = allData;
			console.log(dateIndex);
			console.log(dayIndex);
      //console.
		}
	});
}

function createGraph(data) {
	Papa.parse(dropdownFile.options[dropdownFile.selectedIndex].value, {
		download: true,
		header: false,
		skipEmptyLines: true,
		complete: function(results) {

			var data = results.data;
      var intermediateData = [];
      var duplicateData = [];
      globalData = [];
      globalData = data;

			var dropdownChart = document.getElementById("chartType");
      var dropdownDay = document.getElementById("daySelect");

      var xIndex = [];
      var yIndex = [];
      var allowedIndex = [];
      var allowedIndexDay = [];
      var allowedMonth = [];
      var allowedSub = [];
      var selectedDay = dropdownDay.value;

      var checkboxes = document.getElementsByName('month');
      var subCheckBox = document.getElementsByName('sub');

      for (var i=0; i<checkboxes.length; i++) {
          if (checkboxes[i].checked) {
              allowedMonth.push(checkboxes[i].value);
          }
      }

      for (var i=0; i<subCheckBox.length; i++) {
          if (subCheckBox[i].checked) {
              allowedSub.push(subCheckBox[i].value);
          }
      }

      var dateToUseStart = new Date(formatDate(document.getElementById('startDate').value));
      console.log("Start Date: " + dateToUseStart);

      var dateToUseEnd = new Date(formatDate(document.getElementById('endDate').value));
      console.log("End Date: " + dateToUseEnd);

      allowedIndex.push(0);
      for(var i = 1; i< data.length-1; i++)
      {
        var currentDate = new Date(formatDate(data[i][dateIndex]));

        if(currentDate >= dateToUseStart && currentDate <= dateToUseEnd)
        {
          if(allowedMonth.indexOf((getMonth(data[i][dateIndex]))) > -1){
            if(selectedDay == "week")
            {
              if(allowedSub.indexOf((data[i][subIndex])) > -1)
              {
                allowedIndex.push(i);
              }
            }
            else {
              if(data[i][dayIndex] == selectedDay)
              {
                if(allowedSub.indexOf((data[i][subIndex])) > -1)
                {
                  allowedIndex.push(i);
                }
              }
            }
          }
        }
      }

      //Date Formatting - End

      for(var i = 0; i < xData.length; i++)
      {
        xIndex.push(dataArray.indexOf(xData[i].trim()));
        console.log("xindex" + xIndex);
      }

      for(var i = 0; i < yData.length; i++)
      {
        yIndex.push(dataArray.indexOf(yData[i].trim()));
        console.log("yindex" + yIndex);
      }

			var yAxis = [];
			var xAxis = [];

			for (var k = 0; k < yIndex.length; k++)
      {
        var yCurrent = [];
        for(var i = 0; i < allowedIndex.length; i++)
        {
          if (typeof data[allowedIndex[i]][yIndex[k]] == "undefined")
          {
            data[allowedIndex[i]][yIndex[k]] = "null";
          }
          else {
            yCurrent.push(data[allowedIndex[i]][yIndex[k]]);
          }
        }
        yAxis[k] = yCurrent;
        console.log("current y");
        console.log(yCurrent);
			}

      for(var k = 0; k < xIndex.length; k++)
      {
          var xCurrent = [];
          for(var i = 0; i < allowedIndex.length; i++)
          {
            if (typeof data[allowedIndex[i]][xIndex[k]] == "undefined")
            {
              data[allowedIndex[i]][xIndex[k]] = "null";
            }
            else {
              xCurrent.push(data[allowedIndex[i]][xIndex[k]]);
            }
          }
          xAxis[k] = xCurrent;
          console.log("current x");
          console.log(xCurrent);
      }

			console.log(data);
      console.log("yAxis");
			console.log(yAxis);
      console.log("xAxis");
			console.log(xAxis);

			if(chartType.options[chartType.selectedIndex].value == "line")
			{
        yAxis[0].unshift(yAxis[0][0]);
        var chart = c3.generate({
              data: {
                  columns: [
                      yAxis[0]
                  ]
              },
              axis: {
                  x: {
                      label: xAxis[0][0],
                      type: 'category',
                      culling: true,
                      categories: xAxis[0]

                  },
                  y: {
                      label: yAxis[0][0]
                  }
              },
              grid: {
                  x: {
                      show: true
                  },
                  y: {
                      show: true
                  }
              }
          });

          if(yAxis.length > 1)
          {
            for(var i = 1; i < yAxis.length; i ++)
            {
              yAxis[i].unshift(yAxis[i][0]);
                  chart.load({
                  columns: [
                      yAxis[i]
                  ]
              });
            }
          }
			}
			else if(chartType.options[chartType.selectedIndex].value == "pie"){

				var chart = c3.generate({
				    data: {
				        columns: [
				            xAxis[0],
				        ],
				        type : 'pie',
				        onclick: function (d, i) { console.log("onclick", d, i); },
				        onmouseover: function (d, i) { console.log("onmouseover", d, i); },
				        onmouseout: function (d, i) { console.log("onmouseout", d, i); }
				    }
				});

          if(xAxis.length > 1)
          {
            for(var i = 1; i < xAxis.length; i ++)
            {
                  chart.load({
                  columns: [
                      xAxis[i]
                  ]
              });
            }
          }

			}
			else if(chartType.options[chartType.selectedIndex].value == "bar"){
        yAxis[0].unshift(yAxis[0][0]);
  				var chart = c3.generate({
  						data: {
                //x : xAxis[0][0],
  								columns: [
  										//xAxis[0],
                      yAxis[0]
  								],
  								type: 'bar'
  						},
  						bar: {
  								width: {
  										ratio: 0.7
  								}
  						},
              axis: {
                  x: {
                      label: xAxis[0][0],
                      type: 'category',
                      culling: true,
                      categories: xAxis[0]

                  },
                  y: {
                      label: yAxis[0][0]
                  }
              },
              grid: {
                  x: {
                      show: true
                  },
                  y: {
                      show: true
                  }
              }
  				});

          for(var i =0; i < yAxis.length; i++)
          {
            chart.load({
                columns: [
                    yAxis[i]
                ]
            });
          }

			}
		}
	});
}

function removeElement(elementId) {
    // Removes an element from the document
    var element = document.getElementById(elementId);
    element.parentNode.removeChild(element);
}

function createTable()
{
  document.getElementById("data").innerHTML = "";
  d3.text(dropdownFile.options[dropdownFile.selectedIndex].value, function(data) {
      var parsedCSV = d3.csv.parseRows(data);

      var container = d3.select("#data")
          .append("table")

          .selectAll("tr")
              .data(parsedCSV).enter()
              .append("tr")

          .selectAll("td")
              .data(function(d) { return d; }).enter()
              .append("td")
              .text(function(d) { return d; });
  });
}

parseHeader();
createGraph();
